{ 4A20 DEMO SOFTWARE - POLLED MODE 4A20 READ AND PRINT ROUTINE }


{$R+}    {Range checking }
{$S+}    {Stack checking }
{$I+}    {I/O checking }
{$N-}    {No numeric coprocessor}
{$define main}
uses dos,crt;

{$I 4A20LOW }                 { include low level 4A20 I/O }
{ program polled 4A20 }
const
Escape  : byte = $1B;
NumberOfAverages = 1500;
var
gain : integer;
done : boolean;
index : integer;
average : longint;
channel :  byte;
GainSet : byte;
ADCData : longint;
Regs : Registers;
KeyChar : char;

procedure CheckFor4A20;
begin
  if not CheckGCTable then
  begin
    writeln('Could not find 4A20... aborting program');
    halt(2);
  end; { if }
end; { Check for 4A20 }

begin  { main }
  DirectVideo := false;
  KeyChar :='n';
  CheckFor4A20;
  Reset4A20;
  clrscr;
  writeln('Polled 4A20 data.');
  writeln('I for input offset adj, O for output offset adjust.');
  writeln('F for full scale, adjust to 26214 for 4 volts input');
  writeln('Q for quit.');
  done := false;
  while not done do
  begin
    if keypressed then
    begin
      KeyChar := upcase(readkey);
      case KeyChar of
        'O' : begin gainset := ADGain1; channel := 2; end;
        'I' : begin gainset := ADGain100; channel := 2; end;
        'F' : begin gainset := ADGAin1; channel := 0; end;
        'Q' : done := true;
      end;
    end;
    case gainset of
      ADGain1   : gain := 1;
      ADGain10  : gain := 10;
      ADGain100 : gain := 100;
    end;
    writeln;
    GotoXY(1,10);
    ADCData := PolledConverterReadWithAverage(channel,gainset,NumberOfAverages);
    writeln('Channel ',channel,'  gain ',gain:4,' data ',ADCData:9);
  end;
  If keypressed then readkey;
  halt(1);
end.