{ 4A20 DEMO SOFTWARE - POLLED MODE 4A20 READ AND PRINT ROUTINE }


{$R+}    {Range checking }
{$S+}    {Stack checking }
{$I+}    {I/O checking }
{$N-}    {No numeric coprocessor}

{$DEFINE MAIN}                                 { to allow 4A20 low compile by itself }
uses dos,crt;
{$I 4A20LOW }                 { include low level 4A20 I/O }
{ program polled 4A20 }
const
AverageTimes = 100;

var
channel :  byte;
GainSet : byte;
ADCData : longint;
Regs : Registers;


function KeyPressed : boolean;
  begin
    regs.ah := $0B; {check standard input status }
    MsDos(regs); { Call DOS }
    if regs.al = 0 then KeyPressed := false else KeyPressed := true;
  end; { KeyPressed }

function ReadKey : Char;
  begin
    regs.ah := $07; { direct console input without echo }
    MsDos(regs); { Call DOS }
    ReadKey := Chr(regs.al);
  end; { GetKey }

procedure ClearKeyboardBuffer;
  begin
    regs.ah := $0C;
    regs.al := $0B;
    MsDos(regs); { Call DOS }
  end; { ClearKeyboardBuffer }


procedure CheckFor4A20;
begin
  if not CheckGCTable then
  begin
    writeln('Could not find 4A20... aborting program');
    halt(2);
  end; { if }
end; { Check for 4A20 }

begin  { main }
  CheckFor4A20;
  Reset4A20;
  IdleScanLengthCounter;
  IdleRateCounter;                             { keep timers out of trouble }
  SetMain4A20Mode(PolledMode);                 { setup polled }
  WriteSetup(7,0,0);                           {irq7 drq0 bytemode}
  GainSet := ADGain1;                          { for gain of 1 }
  writeln('Polled 4A20 data.');
  writeln('Press any key to quit.');
  ClearKeyboardBuffer;
  ClrScr;
  while not(KeyPressed) do
    begin
      writeln;
      GotoXY(1,1);
      for  Channel := 0 to 7 do
        begin
          ADCData := PolledConverterReadWithAverage(Channel,GainSet,AverageTimes);
          writeln('Channel ',Channel,' Data ',ADCData,'       ');
        end; { for channel }
    end; { while not(KeyPressed) }
  ClearKeyboardBuffer;
  halt(1);
end.